#include <cpctelera.h>
#include <stdio.h>
#include <string.h>
#include "main.h"

u8 abs (i8 value){
   return (value > 0 ? value : -value);
}

u8 numToCharacter(u8 value) {
  return 48 + value; //48 es el carácter para 0
}

u8 XFromCell(u8 cell){
  return (4 + ((cell % 12) * 4));
}

u8 YFromCell(u8 cell){
  return (20 + ((cell / 12) * 16));
}

u8 CellFromXY (u8 x, u8 y) {
  return  ((y-20)/16)*12 + (x-4)/4;
}

void pause() {
  u16 i;

  for (i = 0; i < SECOND; i++)
    ;
}

void pauseFreeKeyboard(){
	while (cpct_isAnyKeyPressed_f ()) { //Asegurarnos que se ha dejado de pulsar la tecla anterior 
   		//cpct_scanKeyboard_f()
    ;
   	}
}

void pauseKeyPressed(){
  pauseFreeKeyboard();
  while (!cpct_isAnyKeyPressed_f())
      ;
}

u8 pressedUp() {
  if (!dual_stick)
    return (cpct_isKeyPressed(Key_Q) || cpct_isKeyPressed(Key_CursorUp) || cpct_isKeyPressed(Joy0_Up));
  else
    return (cpct_isKeyPressed(Key_W) || cpct_isKeyPressed(Joy0_Up));
}

u8 pressedDown() {
  if (!dual_stick)
    return (cpct_isKeyPressed(Key_A) || cpct_isKeyPressed(Key_CursorDown) || cpct_isKeyPressed(Joy0_Down));
  else
    return (cpct_isKeyPressed(Key_S) || cpct_isKeyPressed(Joy0_Down));
}

u8 pressedLeft() {
  if (!dual_stick)
    return (cpct_isKeyPressed(Key_O) || cpct_isKeyPressed(Key_CursorLeft) || cpct_isKeyPressed(Joy0_Left));
  else
    return (cpct_isKeyPressed(Key_A) || cpct_isKeyPressed(Joy0_Left));
}

u8 pressedRight() {
  if (!dual_stick)
    return (cpct_isKeyPressed(Key_P) || cpct_isKeyPressed(Key_CursorRight) || cpct_isKeyPressed(Joy0_Right));
  else
    return (cpct_isKeyPressed(Key_D) || cpct_isKeyPressed(Joy0_Right));
}

/*u8 sizeString(u8* string){
  u8 i;

  i=1;
  while (*(string) != 0) {
    string++;
    i++;
  }

  return i;
}*/


void clearScreen(){
   u8 x,y;
  u8 pintado;
  
 
  // efecto limpiar pantalla
  x = 0;
  cpct_waitVSYNC();
  while (x < 52) {
    y = 0;
    pintado = 0xFF;
    if (x % 2)
      pintado = 0x00;
    
    while (y <= x) { //patron a 0x00 para fundido a negro; 0xFF para fundido a blanco
      //parece que hay un problema en usar solidbox mientras suena música. No tiene explicación ni está documentado. 
      //Pero me pasa a veces que se cuelga el juego al ejecutar este proceso. Y funciona si deshabilito las INTs 
      //ERROR, creo que el problema era que se estaba llamando a play pero no se había inicializado música
      //__asm
      //  di
      //__endasm;
      cpct_drawSolidBox (cpct_getScreenPtr (mem_start, x-y     ,4*y)      ,pintado,1,4); 
      cpct_drawSolidBox (cpct_getScreenPtr (mem_start, 55-(x-y),4*y)      ,pintado,1,4); 
      cpct_drawSolidBox (cpct_getScreenPtr (mem_start, x-y     ,196-(4*y)),pintado,1,4);
      cpct_drawSolidBox (cpct_getScreenPtr (mem_start, 55-(x-y),196-(4*y)),pintado,1,4); 
     // __asm
     //   ei
      //__endasm;
      y++;
    }
    x++;
  }

  cpct_memset ((u8*) 0xC000, 0x00, 0x4000);

  
 
}


void clearScreens(){
  clearScreen();

  //Limpiar definitivamente ambas pantallas
  cpct_memset ((u8*) 0x8000, 0x00, 0x4000);
}


void changeVideoBuffer(){
  cpct_setVideoMemoryPage(mem_page);  //Visualizar la página preparada
      //Cambiar la pantalla donde pintar para preparar siguiente barrido
      if (swap_memvideo) {
        mem_start = (u8*) 0x8000;
        mem_page = cpct_page80;
      } else {
        mem_start = (u8*) 0xC000;
        mem_page = cpct_pageC0;
      }
}

void updateEnemyPointer(){
  u8 i;
 
  enemies_ptr = &enemies[0];

  i = 0;
  while (i < rooms[screen]) {
    while (enemies_ptr->id){ //mientras el id no sea 0, saltar enemigos
      enemies_ptr++;
    }
    enemies_ptr++; //saltar marca de fin
    i++;
  }
}

void resetEntities (u8 begin) {
  u8 i;

  for (i = begin; i<MAX_ENTITIES; i++) {
    entities[i].x = 0; //Marca de inactivo
    entities[i].x_before_A = 0; //Para que no borre entidades de fases anteriores que hayan dejado sus datos
    entities[i].x_before_B = 0;
  }
}

u8 isCollision(u8 x0, u8 y0, u8 width0, u8 height0, u8 x1, u8 y1, u8 width1, u8 height1) {
//Comprobar colisión entre elemento 0 y elemento 1. 
//Elemento 1 es el que se está calculando la nueva posición
  u8 value;

  value = 0;
  if (x0 + width0 > x1 && x0 < x1 + width1 
    && y0 + height0 > y1 && y0 < y1 + height1) {
    if (y0 + 4 == y1 + height1) //1 colisiona con 0 por arriba de 0
      value = value | 0b00001000;

    if (y0 + height0 == y1 + 4) //1 colisiona con 0 por abajo de 0
      value = value | 0b00000100;

    if (x0 + 1 == x1 + width1) //1 colisiona con 0 por la izquierda de 0
      value = value | 0b00000010;     
    
    if (x0 + width0  == x1 + 1) //1 colisiona con 0 por la derecha de 0
      value = value | 0b00000001;   

    //colisión no controlada Algunos disparos laterales a enemigos no se registraban como colisión. Debe ser por la diferencia de tamaño ¿?
    value = value | 0b10000000; 
  }
  return value;
}


u8 freeCell(u8 enemy) {
  u8 cell, celdaEntidad, exit, i;

  //Devolver una celda donde no esté protagonista ni celdas sólidas
  exit = 0;
  cell = 0;
  celdaEntidad = CellFromXY(entities[0].x,entities[0].y);
  while (!exit) {
    cell = cpct_rand() % 120;
    if (abs(cell - celdaEntidad) > 14) {//Si no está cerca el protagonista, mirar celdas sólidas
      for (i = 0; i < MAX_CELLS_SCREEN; i++) {
        if (cell_buffer[i].x) {
          if (isCollision(cell_buffer[i].x,cell_buffer[i].y,4,16,XFromCell(cell),YFromCell(cell),entities[enemy].width,entities[enemy].height)) {
            break; //No se necesita mirar más, esa celda colisiona
          }
        } else { // Se han revisado todas, la celda es libre
          exit = 1;
          break; //No hay más celdas que revisar
        }
      }
    }
    if (exit) { //Finalmente comprobar si el sprite entrará
      if ((XFromCell(cell) + entities[enemy].width > 51)
        || (YFromCell(cell) + entities[enemy].height > 179))
        exit = 0;
    }
  }

  return cell;
}

/*void cutreZoomModo1 (u8* vmem, void* sprite, u8 x, u8 y, u8 width, u8 height, u8 factor) {
// Tomando como base el sprite "*sprite" situado en x,y con dimensiones width,height,
// hace un escalado por el número indicado por factor tiendo como referencia el centro de la figura original
// Es decir para ver la misma figura con distintos factores de escalado, no se modifica x e y. Ya lo calcula la función
// NO SE HACEN COMPROBACIONES si se pintará fuera de pantalla
// No es óptima, no es rápida, ¡PERO FUNCIONA!

// ¿QUÉ SERIA NECESARIO PARA HACER UNA FUNCION GENERICA PARA LOS 3 MODOS ¿ES POSIBLE?
  u8 xc,yc,x0,y0;
  u8 i,j,k,l,m,*ptr;
  u8 byte, color, mascara, pixelFinal;
  

  // Calcular centro
  xc = x + (width/2);
  yc = y + (height/2);

  // Calcular x e y
  x0 = xc - ((width/2) * factor);
  y0 = yc - ((height/2) * factor);

  ptr = sprite;
  //Recorreré cada pixel ancho por alto del sprite escalado e iré cogiendo el pixel del original
  for (i = 0; i < height; i++){
    for (j = 0; j < width; j++){
      for (k = 0; k < factor; k++){
        //obtenemos los valores codificados de los 2 colores del byte
        //Un byte contiene 4 pixeles, o sea cuatro colores que se codifican de la siguiente manera
        //Byte 94 correspondería a los colores 2,1,0 y 1 (en ese orden)
        //0x53 = 0101 0011 
        //Si tomamos el orden como b7,b6,...b0 del byte. 
        //El primer  color sale de coger los bits de los lugares 3 y 7 = 00 => Color 0 de la paleta
        //El segundo color sale de coger los bits de los lugares 2 y 6 = 01 => Color 1 de la paleta
        //El tercer  color sale de coger los bits de los lugares 1 y 5 = 10 => Color 2 de la paleta
        //El cuarto  color sale de coger los bits de los lugares 0 y 4 = 11 => Color 3 de la paleta
        
        //Si el factor es par, la primera mitad será del color1; la segunda de color2
        //Para codificar un color consigo mismo, depende de si es el color1 o es el color2 hay que hacer un OR consigo mismo
        // desplazando a la derecha o la izquierda respectivamente.

        pixelFinal = 0;        
        for (m=0; m < 4; m++){
          byte = *ptr;
          *((u8*) 0xFFFC) = byte;   

          color = ((4 * k)+m)/factor; //Saber qué color hay que coger
          mascara = 0b10001000;

          mascara = mascara >> color;
          byte = byte & mascara; // Obtener sólo el color a añadir
          
          if (m > color)
            byte = byte >> (m - color) ; //Tener en cuenta cuántos desplazamientos hay que hacer para ponerlo en su sitio
          else
            byte = byte << (color - m) ;

          pixelFinal = pixelFinal | byte;
          // Depurar
          //Para el byte 53 => 0101 0011 => 4 pixels con color1 color2 color3 color4, van saliendo los siguientes valores:
          //k           0   0   0   0   1
          //m           0   1   2   3   0
          //byte        00  00  20  10  08
          //mascara     88  88  44  44  22
          //pixelFinal  00  00  20  30  08
          // *((u8*) 0xFFF8) = i;   
          // *((u8*) 0xFFF9) = j;   
          // *((u8*) 0xFFFA) = k;   
          // *((u8*) 0xFFFB) = m;    
          //     
          // *((u8*) 0xFFFD) = mascara;       
          // *((u8*) 0xFFFE) = byte;    
          // *((u8*) 0xFFFF) = pixelFinal;       
          //cpct_waitVSYNC();
        }

        for (l=0;l<factor;l++) {
          //Pintar en Memoria de Vídeo el Byte Resultante
          *(cpct_getScreenPtr (vmem, x0+(j*factor)+k,y0+(i*factor)+l)) = pixelFinal;
        }
      }
      ptr++;  //Cogemos siguiente Byte del sprite
    }
  } 
}*/