#include <cpctelera.h>
#include <stdio.h>
#include <string.h>
#include "main.h"
#include "graphics.h"
#include "funciones.h"
#include "render.h"
#include "m_game.h"
#include "m_menu.h"

u8 new_score;
u8 music_changed;

void shuffleRooms() {
	u8 i,j,a,b,c;

	//Mezclar las pantallas por mundos
	for (i=0; i<4; i++) {
		for (j=0; j<20; j++) {
			//No se barajan la primera habitación de cada mundo, ni de los jefes ni la previa
			a = (i*10) + (cpct_rand() % 7) + 2;
			b = (i*10) + (cpct_rand() % 7) + 2;
			
			c = rooms[a];
			rooms[a] = rooms[b];
			rooms[b] = c;
		}
	}
}

void resetValues() {
	u8 i;

	max_energy = 70;
	// Protagonista
	entities[0].x = 26;
	/*Llevado al init del tutorial
	entities[0].id = 0;
	entities[0].height = 16;
	entities[0].width = 4;
	entities[0].frozen = 0;*/
	entities[0].movV = 0;
	entities[0].movH = 0;
	entities[0].sprite_f1 = (u8*) &G_anima_down_f1[0];
	entities[0].sprite_f2 = (u8*) &G_anima_down_f2[0];
	entities[0].energy = max_energy;
	entities[0].attack = 2;

	//Disparo
	entities[1].height = 8;
	entities[1].width = 2;
	entities[1].sprite_f1 = (u8*) &G_shot_f1[0];
	entities[1].sprite_f2 = (u8*) &G_shot_f2[0];

	//Power-ups
	for (i=0;i<12;i++)
	 	powerups[i]=2; //Inicialmente todos disponibles pero ocultos

	for (i=0;i<5;i++) {
	 	powerupsTaken[i]=255; //Inicialmente ninguno cogido
	}

	ptr_powerupsTaken = 0;

	frame = 0;
	swap_memvideo = 0;
	mem_start = (u8*) 0xC000;
   	mem_page = cpct_pageC0;

	//OPT? enemies_ptr = &enemies[0];

	powerup = 0;
	score = 0;
	level = 0;
	bonus = 1;
	target_level = 0;
	restart = 0;
	
	shuffleRooms();
}

void gameOver(){

	entities[0].energy = 0; 
	//Para que no salgan protagonista y disparo luego en el pintado de sprites del menú
	//entities[0].y = 0;
	entities[1].x = 0;
	entities[0].sprite_f1 = (u8*) &G_anima_dead[0];
	entities[0].sprite_f2 = (u8*) &G_anima_dead[0];
	//intr:5, nota:C3 => (3*12) + 1 -1 = 36
	playFX (5,36);
	//Silenciar temporalmente los otros dos canales para que no se mezcle con la música que esté sonando
	cpct_akp_SFXPlay (5, 0, 36, 0, 0, AY_CHANNEL_A);
	cpct_akp_SFXPlay (5, 0, 36, 0, 0, AY_CHANNEL_C);
	if (powerups[3]) { //No mostrar GAME OVER si tenemos vida extra (powerups[3]==0)
		renderText((u8*) 0xC000,5,0);
		music_speed++; //Volver a poner música a velocidad normal
	}
	
	end_screen = 2;
}

void checkPowerUp() {
	u8 i,j,k;

	//Resetear entidades enemigas por si quedan disparos al morir el origen
	//Dejar que sigan hasta desaparecer. Sin disparo homing ya no importa
	//resetEntities(2);

	k=0;
	// Restablecer powerups que hayan salido antes pero no se hayan escogido
	//powerups[0..11] == 2 indicará que está disponible para entrar en la 'baraja'
	for (i=0; i < 12; i++) {
		if (powerups[i] == 1)
			powerups[i] = 2;
	}

	if (screen == 1) {
		//Tras el primer nivel podremos coger 2 power-ups, uno de ellos será el caramelo siempre
		//powerupsOnScreen[0..3] los 4 powerups a mostrar en pantalla
		//powerups[0..11] == 1 son los que van a a estar en pantalla
		//powerup = nº de items a coger
		powerup = 2;
		k = cpct_rand() & 0x03;
		powerupsOnScreen[k] = 11;
		powerups[11] = 1;
	}

	if (screen % 10 == 0) 
		powerup = 1;

	if (restart && powerup) {
		powerup--;
	}
	
	if (powerup) {
		//Según la posición del prota al completar la pantalla, mostrar los powerups arriba o abajo
    	y_powerups = 52;
    	if (entities[0].y < 100)
    		y_powerups = 148;
	    

		//Mezclar los 4 power ups que vayan a salir
		i = 0;
		//*** OJO: BULCE INFINITO si j no va cogiendo nuevos valores ***
		while (i < 4){
			if (screen == 1 && i == k) { //Ese 'slot' ya está asignado
				i++;
			} else {
				j = cpct_rand() % 12; //Barajar del power-up 0 al 11

				//j = 3; powerups[j] = 2;

				if (powerups[j] == 2) {
					powerups[j] = 1;
					powerupsOnScreen[i] = j;
					i++;
				}
			}
		}
		//renderText((u8*) 0x8000,6,0);
		renderText((u8*) 0xC000,6,0);
	}
}

void initEnemy (u8 n, u8 id, u8 energy, u8 attack, i8 movH, i8 movV, u8 height, u8 width, u8* sprite, i8 data2, u8 flip) {
	entities[n].id = id;
	entities[n].x = enemies_ptr->x;
	entities[n].y = enemies_ptr->y;
	entities[n].x_before_A = 0; //Para que no se ejecute renderDelete sobre un enemigo que haya dejado datos aquí
	entities[n].x_before_B = 0;
	entities[n].energy = energy;
	entities[n].attack = attack;   		
	entities[n].movH = movH;
	entities[n].movV = movV;
	entities[n].height = height;
	entities[n].width = width;
	entities[n].sprite_f1 = sprite;
	entities[n].data1 = 1;
	entities[n].data2 = data2;
	entities[n].immunity = RESET_ENEMY;
	entities[n].frozen = 0;
	entities[n].flip = flip;

	if (!powerups[4])
	   		entities[n].frozen = 10; //Empezar quietos unos instantes

	//Los sprites se guardan correlativos por lo que es fácil inicializar el segundo frame de manera genérica 
	//en vez de asignación por tipo de enemigo
	entities[n].sprite_f2 = (u8*) (&entities[n].sprite_f1[0] + (entities[n].width * entities[n].height));

	}

void enemyGenerator (u8 n) {
	if (enemies_ptr->id) {
	   	
		if (enemies_ptr->id == 2) { //Zombie
			initEnemy (n, 2, ENERGY_ZOMBI, ATTACK_ZOMBI, 1, 0, 16, 3, (u8*) &G_zombie_f1[0], 1, 0);
		}   
		if (enemies_ptr->id == 3) { //Escorpión
			initEnemy (n, 3, ENERGY_SCORPIO, ATTACK_SCORPIO, 0, 1, 16, 3, (u8*) &G_scorpio_f1[0], 0, 0);
		}   
		if (enemies_ptr->id == 4) { //Abejas
			initEnemy (n, 4, ENERGY_BEE, ATTACK_BEE, 0, 0, 16, 4, (u8*) G_bee_f1, 30, 0);
		}  
		if (enemies_ptr->id == 5) { //Perro
			initEnemy (n, 5, ENERGY_DOG, ATTACK_DOG, 0, 0, 16, 4, (u8*) G_dog_f1, 2, 1);
		}  
		if (enemies_ptr->id == 6) { //Araña
			initEnemy (n, 6, ENERGY_SPIDER, ATTACK_SPIDER, 0, 0, 16, 3, (u8*) G_spider_f1, 50, 0);
		}   
		if (enemies_ptr->id == 7) { //Boss Lvl 1
			initEnemy (n, 7, ENERGY_BOSS1, ATTACK_BOSS1, 1, 1, 64, 8, (u8*) G_boss1_f1, 20, 0);
		}  
		if (enemies_ptr->id == 8) { //Tiburón
			initEnemy (n, 5, ENERGY_SHARK, ATTACK_SHARK, 0, 0, 16, 5, (u8*) G_shark_f1, 2, 1);
		}
		if (enemies_ptr->id == 9) { //Pulpo
			initEnemy (n, 9, ENERGY_OCTOPUS, ATTACK_OCTOPUS, 0, 0, 16, 5, (u8*) G_octopus_f1, 70, 0);
		}
		if (enemies_ptr->id == 10) { //Serpiente
			initEnemy (n, 10, ENERGY_SNAKE, ATTACK_SNAKE, 0, 0, 16, 2, (u8*) G_snake_f1, 60, 0);
	   		if (cpct_rand() & 0x01)
	   			entities[n].movH = 1;
	   		else
	   			entities[n].movV = 1;
 		}
 		if (enemies_ptr->id == 11) { //Estrella de mar
 			initEnemy (n, 11, ENERGY_STARFISH, ATTACK_STARFISH, 0, 0, 16, 4, (u8*) G_starfish_f1, 80, 0);
		}
		if (enemies_ptr->id == 12) { //Cocodrilo
			initEnemy (n, 12, ENERGY_CROCODILE, ATTACK_CROCODILE, 1, 0, 12, 5, (u8*) G_crocodile_f1, 0, 1);
		}
		if (enemies_ptr->id == 13) { //Boss Lvl 2
			initEnemy (n, 13, ENERGY_BOSS2, ATTACK_BOSS2, 1, 0, 48, 12, (u8*) G_boss2_f1, 0, 0);
		} 
		if (enemies_ptr->id == 14) { //Calavera
			initEnemy (n, 14, ENERGY_SKULL, ATTACK_SKULL, 1, 1, 16, 3, (u8*) G_skull_f1, 0, 0);
		} 
		if (enemies_ptr->id == 15) { //Esqueleto
			initEnemy (n, 11, ENERGY_SKELETON, ATTACK_SKELETON, 0, 0, 20, 3, (u8*) G_skeleton_f1, 60, 0);
		}
		if (enemies_ptr->id == 16) { //Armadura
			initEnemy (n, 5, ENERGY_ARMOR, ATTACK_ARMOR, 0, 0, 20, 3, (u8*) G_armor_f1, 1, 0);
		}
		if (enemies_ptr->id == 17) { //Slime
			initEnemy (n, 10, ENERGY_SLIME, ATTACK_SLIME, 1, 1, 12, 4, (u8*) G_slime_f1, 45, 1);
	   		if (cpct_rand() & 0x01)
	   			entities[n].movH = 1;
	   		else
	   			entities[n].movV = 1;
		}
		if (enemies_ptr->id == 18) { //Demonio
			initEnemy (n, 9, ENERGY_DEMON, ATTACK_DEMON, 0, 0, 16, 4, (u8*) G_demon_f1, 50, 1);
		}
		if (enemies_ptr->id == 19) { //Boss Lvl 3
			initEnemy (n, 19, ENERGY_BOSS3, ATTACK_BOSS3, 0, 0, 32, 14, (u8*) G_boss3_f1, 20, 0);
			if (cpct_rand() & 0x01)
				entities[n].movH = 1;
			else
				entities[n].movV = 1;
		}
		if (enemies_ptr->id == 20) { //Murciélago
			initEnemy (n, 4, ENERGY_BAT, ATTACK_BAT, 0, 0, 8, 4, (u8*) G_bat_f1, 20, 0);
		}
		if (enemies_ptr->id == 21) { //Momia
			initEnemy (n, 5, ENERGY_MUMMY, ATTACK_MUMMY, 0, 0, 20, 4, (u8*) G_mummy_f1, 1, 0);
		}
		if (enemies_ptr->id == 22) { //Bruja
			initEnemy (n, 9, ENERGY_WITCH, ATTACK_WITCH, 0, 0, 20, 3, (u8*) G_witch_f1, 70, 1);
		}
		if (enemies_ptr->id == 23) { //Llama
			initEnemy (n, 11, ENERGY_FLAME, ATTACK_FLAME, 0, 0, 16, 4, (u8*) G_flame_f1, 50, 1);
		}
		//if (enemies_ptr->id == 24) { //Monstruo
		//	entities[n].energy = ENERGY_MONSTER;
	   	//	entities[n].attack = ATTACK_MONSTER;
		//	entities[n].movH = 1;
	   	//	entities[n].sprite_f1 = (u8*) &G_monster_f1[0]; 
		//} 
		if (enemies_ptr->id == 25) { //Boss Lvl 4
			initEnemy (n, 25, ENERGY_BOSS4, ATTACK_BOSS4, 1, 1, 32, 8, (u8*) G_boss4_f1, 0, 0);
		}
		//entities[n].data1 = entities[n].data2;
		
		enemies_ptr++; //Puntero a siguiente enemigo
	} else {
		enemies_on_screen--; //No hay enemigo nuevo, restar al contador

		//Si se han eliminado todos los enemigos mostrar powerups en fases concretas
		if (!enemies_on_screen && afterIntro && screen < LAST_SCREEN){ 
			checkPowerUp();
		}
	}
}

void levelUp(){
	if (level < 5) {
		level++;
	
		if (level == 4) {
			entities[0].attack--; //En level 4 no se aumenta ataque	
			//Para pasar a nivel 5 hay que llegar al último escalón.
			//Si hemos cogido el powerup de Level+1 target_level sería 2, en vez de 3
			target_level == 3; 
		}

		entities[0].attack++;
		if (max_energy <= 105)
			max_energy += 5;

		entities[0].energy = max_energy;
		//intr:6, nota:C3 => (3*12) + 1 -1 = 36
		playFX (6,36);
		renderText((u8*) 0xC000,2,level);
		renderEnergy((u8*) 0xC000);
		renderExp();
	}
}

void initScreen() {
	u8 i;

	//Música 
	if (screen == 11) {
		music_speed = 7;
		cpct_akp_musicInit((u8*) m_menu);
		music_changed = 0;
	} 

	if (screen == 1 || screen == 31) {
		music_speed = 6;
		cpct_akp_musicInit((u8*) m_game);
		music_changed = 0;
	}

	for (i=0; i < MAX_CELLS_SCREEN; i ++) { 
		cell_buffer[i].x = 0;
	}

	clearScreens();
	text_buffer = 0; 
	//Reset de todas las entidades
	resetEntities(0);

	renderFixedElements((u8*) 0x8000);
	renderFixedElements((u8*) 0xC000);
	//Borrar y resetear si se ha pintado los enemigos por el powerup forsee
	if (!powerups[4]) {
		pause(); pause();
		renderDelete();
		resetEntities (0);
	}
	

	//Volver a pintar elementos fijos, algun tile puede haber sido borrado
	//por el renderDelete por la posición de algún enemigo
	//renderFixedElements((u8*) 0x8000);
	//renderFixedElements((u8*) 0xC000);

	updateEnemyPointer();

	//Posición inicio protagonista y dirección disparo
	entities[0].x = 26;
	entities[0].y = 164;
	entities[0].immunity = RESET_ANIMA;
	entities[1].data1 = -1; //Por defecto, disparar hacia arriba
	entities[1].data2 = 0;
	touched = 0;

	enemies_on_screen = 2;
	if (screen > 11 || screen == 40) {
		enemies_on_screen = 3; 
	}
	if (screen > 21) {
		enemies_on_screen = 4;
	}
	if (screen == 10 || screen == 20 || screen == 30) {
		enemies_on_screen = 1; 
	}

	for (i=2; i<enemies_on_screen+2; i++){
		enemyGenerator (i);
	}

	time = RESET_TIME;
}

void keyboard(){

	entities[0].movV = 0;
	entities[0].movH = 0;

	if (pressedUp()) {
		entities[0].movV = -1;
		entities[0].sprite_f1 = (u8*) &G_anima_up_f1[0];
		entities[0].sprite_f2 = (u8*) &G_anima_up_f2[0];
	}

	if (pressedDown()){
		entities[0].movV = 1;
		entities[0].sprite_f1 = (u8*) &G_anima_down_f1[0];
		entities[0].sprite_f2 = (u8*) &G_anima_down_f2[0];
	}

	if (pressedLeft()){
		entities[0].movH = -1;
		entities[0].sprite_f1 = (u8*) &G_anima_left_f1[0];
		entities[0].sprite_f2 = (u8*) &G_anima_left_f2[0];
	}

	if (pressedRight()){
		entities[0].movH = 1;
		entities[0].sprite_f1 = (u8*) &G_anima_right_f1[0];
		entities[0].sprite_f2 = (u8*) &G_anima_right_f2[0];
	}

}

void shoot(){
	//Guardar último movimiento del protagonista para nuevo disparo
	if (entities[0].movV || entities[0].movH) {
		entities[1].data1 = entities[0].movV;
		entities[1].data2 = entities[0].movH;	
	}

	//Si no había disparo, disparar cuando se deje de mover al protagonista
	if (!entities[1].x && !entities[0].movV && !entities[0].movH ) { 
		entities[1].movV = entities[1].data1;
		entities[1].movH = entities[1].data2;
		//Que salga desde el centro del protagonista 4Bx16px
		entities[1].x = entities[0].x + 1;
		entities[1].y = entities[0].y + 4;
	}
}

void shootDual(){
	if (!entities[1].x) {
		entities[1].movV = 0;
		entities[1].movH = 0;
		if (cpct_isKeyPressed(Key_CursorLeft) || cpct_isKeyPressed(Joy1_Left))
			entities[1].movH = -1;

		if (cpct_isKeyPressed(Key_CursorRight) || cpct_isKeyPressed(Joy1_Right))
			entities[1].movH = 1;

		if (cpct_isKeyPressed(Key_CursorUp) || cpct_isKeyPressed(Joy1_Up))
			entities[1].movV = -1;

		if (cpct_isKeyPressed(Key_CursorDown) || cpct_isKeyPressed(Joy1_Down))
			entities[1].movV = 1;
  	
		if (entities[1].movV || entities[1].movH) { 
			//Que salga desde el centro del protagonista 4Bx16px
			entities[1].x = entities[0].x + 1;
			entities[1].y = entities[0].y + 4;
		}
	}
}

void shootEnemy(u8 entity) { 
	u8 n;

	//Buscar primer hueco en la tabla entidades para el disparo
	n = 2 + enemies_on_screen;
	while (n < MAX_ENTITIES) { 
		if (!entities[n].x)
			break;
		else
			n++;
	}
	
	if (n < MAX_ENTITIES) { //Había hueco para crear un nuevo disparo
		entities[n].id = 255;
		entities[n].height = 8;
		entities[n].width = 2;
		entities[n].sprite_f1 = (u8*) &G_shot_en2_f1[0];
		entities[n].sprite_f2 = (u8*) &G_shot_en2_f2[0];
		entities[n].x = entities[entity].x + (entities[entity].width/2);
		entities[n].y = entities[entity].y + (entities[entity].height/2);

		entities[n].immunity = 255; //El disparo enemigo no se puede destruir
		entities[n].attack = entities[entity].attack/2; //Coger como ataque la mitad del ataque del enemigo que dispara 
		entities[n].data1 = 1; //Para que dispare en la siguiente iteración
		entities[n].frozen = cpct_rand() % 20;
		//entities[n].flip = 0;
	}
}

void resetData1(u8 i){
	//resetear data1 de IA, pero con un factor aleatorio de +0 a +10
	entities[i].data1 = entities[i].data2 + (2 * (cpct_rand() % 6));
}

void iA(){
	u8 i,cell;
	for (i = 0; i < MAX_ENTITIES; i++) {
		if (entities[i].x) {
//Movimiento aleatorio (Abejas, ....)
			if (entities[i].id == 4) { 
				entities[i].data1--;
				if (!entities[i].data1) {
					entities[i].movV = 1 - (cpct_rand() % 3);
					entities[i].movH = 1 - (cpct_rand() % 3);
					resetData1(i);
				}
			}
//Persecución dinámica al protagonista (Perro, TIburón, .... Disparo)
			if (entities[i].id == 5) { 
				entities[i].data1--;
				entities[i].movH = 0;
				entities[i].movV = 0;				
				if (!entities[i].data1) {
					if (entities[i].x < entities[0].x){
						entities[i].movH = 1;
					} 
					if (entities[i].x > entities[0].x){
						entities[i].movH = -1;
					} 
					if (entities[i].y < entities[0].y){
						entities[i].movV = 1;
					} 
					if (entities[i].y > entities[0].y){
						entities[i].movV = -1;
					}
					//Una de cada 6 se mueve en dirección contraria para que no sea tan predecible
					/*if ((cpct_rand() % 6) == 0) {
						entities[i].movH = entities[i].movH * -1;
						entities[i].movV = entities[i].movV * -1;
					}*/
					resetData1(i);
				}
			} 
//Desaparecer (pulpo, estrella de mar, ...)			
			if (entities[i].id == 9 || entities[i].id == 11) {
				entities[i].data1--;
				if (!entities[i].data1) {
					cell = freeCell (i); //Buscar celda libre de sólido y protagonista
					entities[i].x = XFromCell(cell);
					entities[i].y = YFromCell(cell);

					resetData1(i);
					//Los que también van a disparar, restablecerán su valor data1 en la parte de Disparo
					if (entities[i].id == 9)
						entities[i].data1 = 0;
				}
			}
//Cambiar coordenada de dirección (serpiente, Boss3, ...)			
			if (entities[i].id == 10 || entities[i].id == 19) {
				entities[i].data1--;
				if (!entities[i].data1) {
					//Cambiar dirección
					if (entities[i].movH) {
						entities[i].movH = 0;
						entities[i].movV = 1;
					} else {
						entities[i].movH = 1;
						entities[i].movV = 0;
					}

					resetData1(i);
					//Los que también van a disparar, restablecerán su valor data1 en la parte de Disparo
					if (entities[i].id == 19)
						entities[i].data1 = 0;
				}
			}
//Disparar al protagonista (Araña, Boss1, Pulpo, Boss2, ..)
			if (entities[i].id == 6 || entities[i].id == 7 || entities[i].id == 9 || entities[i].id == 19) {
				//Algunos tipos ya restaron su ciclo  en una mecánica anterior (desaparecer o cambiar coordenada) 
				if (entities[i].id != 9 && entities[i].id != 19) {
					entities[i].data1--;
				}
				
				if (!entities[i].data1) {
					//Crear entidad disparo
					shootEnemy(i);

					resetData1(i);
				}
			}

			if (entities[i].id == 13) {
				if (!(cpct_rand() & 0x03))
					shootEnemy(i);
			}
//Persecución (o disparo) fija (por posición de origen del protagonista)
			if (entities[i].id == 255) { 
				entities[i].data1--;
				if (!entities[i].data1) {
					entities[i].movH = 0;
					entities[i].movV = 0;
					if (entities[i].x + entities[i].width < entities[0].x){
						entities[i].movH = 1;
					}  
					if (entities[i].x > entities[0].x + 4){
						entities[i].movH = -1;
					}
					if (entities[i].y + entities[i].height < entities[0].y){
						entities[i].movV = 1;
					} 
					if (entities[i].y > entities[0].y + 16) {
						entities[i].movV = -1;
					}
					//Si no hay movimiento, disparar hacia abajo
					if (!entities[i].movH && !entities[i].movV)
						entities[i].movV = 1;

					//entities[i].data1 = entities[i].data2;
				}
			}
		}
	}

}

void movementsAllowed() {
	u8 i,j,x,y;
	u8 colisionTotal, colisionArea, colisionCells;
	u8 celdaEntidad;

	for (i = 0; i < MAX_ENTITIES; i++) {
		colisionArea = 0;
		colisionCells = 0;
		if (entities[i].x) { //Para entidades vivas 
			if (entities[i].frozen) {
				entities[i].frozen--;
			} else {
				x = entities[i].x;
				y = entities[i].y;

				if (entities[i].movV || entities[i].movH) {
					if (entities[i].movV == -1)
						y = y - 4;

					if (entities[i].movV == 1)
						y = y + 4;

					if (entities[i].movH == -1)
						x = x - 1;

					if (entities[i].movH == 1)
						x = x + 1;

					//Comprobación Área de juego
					//Comprobar que no se salga del borde Vertical
					if (end_screen && i == 0 && x >= 24 && x <=28 && y <= (PLAYAREA_SUP + 1)) {//caso especial para seguir subiendo por el hueco de la puerta
						entities[i].y = y;
					} else {
						if (y > PLAYAREA_SUP && y < (PLAYAREA_INF - entities[i].height)) {
							;//entities[i].y = y;
						} else { //No se puede hacer el movimiento
							colisionArea = 4;
							y = entities[i].y;
						}
					}
					
					//Comprobar que no se salga del borde HORIZONTAL
					if (x > 3 && x < 53 - entities[i].width) {
						;//entities[i].x = x;
					} else { //No se puede hacer el movimiento
						colisionArea = 1;
						x = entities[i].x;
					}
					
					celdaEntidad = CellFromXY(x,y);

					for (j = 0; j < MAX_CELLS_SCREEN; j++) {
						if (cell_buffer[j].x) {
							if (abs(cell_buffer[j].cell - celdaEntidad) < 14) {
								colisionCells = colisionCells | isCollision(cell_buffer[j].x,cell_buffer[j].y,4,16,x,y,entities[i].width,entities[i].height);
								/*if (colisionCells){
									// Si hay colisión no se permite moverse a ningún lado
									x = entities[i].x;
									y = entities[i].y;
								}*/
								if ((colisionCells & 0b00001000 && entities[i].movV == 1) //colisión vertical, restablecer y según si se movía a esa dirección
									|| (colisionCells & 0b00000100 && entities[i].movV == -1)) {
									y = entities[i].y;
									if (i == 0) {
										//Volver a averiguar si hay colisión con la y rectificada para efecto
										//deslizamiento en coordenada X
										colisionCells = isCollision(cell_buffer[j].x,cell_buffer[j].y,4,16,x,y,entities[i].width,entities[i].height);
									}
								}
								if ((colisionCells & 0b00000010 && entities[i].movH == 1) //colisión horizontal, restablecer x según si se movía a esa dirección
									|| (colisionCells & 0b00000001 && entities[i].movH == -1)) {
									x = entities[i].x;
								}	
							}	
						} else
							break; //No hay más celdas que revisar
					}
					

					colisionTotal = colisionArea | colisionCells;
					//Permitir donde no hubo colisión, para efecto deslizamiento en pared
					entities[i].y = y; 
					entities[i].x = x;

					if (colisionTotal) { 
						//*((u8*) 0xFFFF) = (u16) cpct_getScreenPtr (CPCT_VMEM_START,26,76);
						if (i == 1 || entities[i].id == 255) {//Reiniciar Disparo (propio o de enemigos)
							entities[i].x = 0;
						} 
						if (i > 1) {//rebotar enemigos
							if (colisionTotal & 0b00001100){
								entities[i].movV = entities[i].movV * -1;
							}

							if (colisionTotal & 0b00000011){
								entities[i].movH = entities[i].movH * -1; 
							}
						}
					}
				}
			}
		}
	}
}

void collisions(){
	u8 i,j,nuevoEXP,ataque;
	u32 overflow;

//cpct_setBorder(HW_BLACK);
	if (entities[0].immunity) {
		entities[0].immunity--;
	}

	for (i = 2; i < MAX_ENTITIES; i++) {
		if (entities[i].x) {
			
			//Colisión protagonista con enemigos (si no está en inmunidad ninguno de ambos)
			//Los disparos enemigos tienen inmunidad a 0, renerlo en cuenta
			if (!entities[0].immunity && (!entities[i].immunity || entities[i].id == 255) && entities[0].energy) {
				if (isCollision(entities[0].x,entities[0].y,4,16,
					entities[i].x,entities[i].y,entities[i].width,entities[i].height)) {
//cpct_setBorder(HW_WHITE);
					//intr:2, nota:G4 => (4*12) + 8 -1 = 55
					playFX (2,55);
					touched = 1;
					bonus = 1; //Resetear bonus
					renderBonus();

					if (entities[i].attack < entities[0].energy) {
						entities[0].energy = entities[0].energy - entities[i].attack;
					} else {
						//Muerte - Game Over
						gameOver();
						break;
					}
					entities[0].immunity = RESET_ANIMA;
					renderEnergy((u8*) 0xC000);
					//renderEnergy((u8*) 0x8000);
					renderText((u8*) 0xC000,1,entities[i].attack);
					//renderText((u8*) 0x8000,1,entities[i].attack);
				}
			}
			
			//Colisión enemigos con disparo (si no está en inmunidad)
			if (entities[i].immunity) {
				entities[i].immunity--;
			} else {
				if (isCollision(entities[1].x,entities[1].y,entities[1].width,entities[1].height,
					entities[i].x,entities[i].y,entities[i].width,entities[i].height)) {			
//cpct_setBorder(HW_RED);
					//intr:1, nota:C3 => (3*12)+1-1 = 36
					playFX (1,36);
					entities[1].x = 0; //Quitar disparo (no traspasará)
					ataque = entities[0].attack;
					//Posible ataque crítico (suma 2)
					if (!powerups[1] && !(cpct_rand() % 5)) {
						ataque = ataque * 2;
						renderText((u8*) 0xC000,8,0);
						//renderText((u8*) 0x8000,8,0);
					}
					//Congelar los enemigos el doble de su tiempo de inmunidad (no les afecta a Bosses)
					if (!powerups[9] && entities[i].attack < 15) 
						entities[i].frozen = RESET_ENEMY * 2;

					if (ataque < entities[i].energy) {
						entities[i].energy = entities[i].energy - ataque;
					} else {
						entities[i].energy = 0;
						entities[i].x = 0;
						//Borrar Sprite de ambos buffers, no se puede dejar para ciclo normal porque 
						//el siguiente enemigo puede tener distintas dimensiones
						//También poner x_before para que no se borre, pues las dimensiones ya habrán cambiado
						//con enemyGenerator
						if (afterIntro) {
							cpct_drawSolidBox (cpct_getScreenPtr ((u8*) 0x8000, entities[i].x_before_A, entities[i].y_before_A),0x00,entities[i].width, entities[i].height); 
							cpct_drawSolidBox (cpct_getScreenPtr ((u8*) 0xC000, entities[i].x_before_B, entities[i].y_before_B),0x00,entities[i].width, entities[i].height); 
						}
						

						//Puntuación
						new_score = 5; 						
						if (entities[i].id == 4)
							new_score = 25;
						if (entities[i].id == 5)
							new_score = 10;
						if (entities[i].id == 6)
							new_score = 20;
						if (entities[i].id == 9)
							new_score = 50;
						if (entities[i].id == 10)
							new_score = 30;
						if (entities[i].id == 11)
							new_score = 20;
						if (entities[i].height >= 32) //Bosses
							new_score = 100;
						
						//Multiplicador de puntos (x2)
						if (!powerups[8]) 
							new_score = new_score *2;

						//Comprobar posible overflow
						overflow = score + (new_score * bonus);
						if (overflow > 65535)
							score = 65535;
						else
							score = overflow;
						
						//Bonus
						if (bonus < 5) {
							bonus++;
							renderBonus();
						}
						time = RESET_TIME;
						
						//EXP
						nuevoEXP = 1;
						if (target_level == 0 && score > 1000){
							;
						}
						else if (target_level == 1 && score > 5000){
							;
						}
						else if (target_level == 2 && score > 10000){
							;
						}
						else if (target_level == 3 && score > 20000){
							;
						}
						else {
							nuevoEXP = 0;
						}
						
						if (nuevoEXP) {
							target_level++;
							levelUp();
						}

						//Generar siguiente enemigo
						enemyGenerator(i);
					}
					entities[i].immunity = RESET_ENEMY;
				}
			}
		}
	}

	if (powerup) { //Si estamos en modo power-up ver si prota ha cogido caja
		//Tenemos CPU de sobra, usamos la función isCollision aunque no sea eficiente
		for (i=0;i<4;i++) {
			if (powerupsOnScreen[i] != 255 && isCollision(entities[0].x,entities[0].y,4,16,	8 + (12*i),y_powerups,4,16)){
				//Si estamos en segunda vuelta restar el puntero para que se asigne al último slot y desactivar el último power-up
				if (restart) {
					ptr_powerupsTaken--;
					powerups[powerupsTaken[ptr_powerupsTaken]] = 2;
				}
				
				j = powerupsOnScreen[i];
				powerupsTaken[ptr_powerupsTaken] = j;
				powerupsOnScreen[i] = 255;
				powerups[j] = 0; //marcarlo como cogido y activo. Ya no volverá a salir
				//intr:3, nota:E4 => (4*12)+5-1 = 52
				playFX (3,52);
				//Mostrarlo en el marcador
				cpct_drawSprite (&G_power_up1[0] + 64*j, cpct_getScreenPtr ((u8*) 0x8000, 58 + (ptr_powerupsTaken*4),   180), 4, 16);
				cpct_drawSprite (&G_power_up1[0] + 64*j, cpct_getScreenPtr ((u8*) 0xC000, 58 + (ptr_powerupsTaken*4),   180), 4, 16);
				ptr_powerupsTaken++;

				powerup--;
				renderPowerUp(mem_start);
				//renderText((u8*) 0x8000, 7,j);
				renderText((u8*) 0xC000, 7,j);
				pause();
				//Activación de Powerups inmediatos
				if (j == 0) { //Disparo más grande pero más débil
					entities[1].height = 12;
					entities[1].width = 3;
					entities[1].sprite_f1 = (u8*) &G_shot2_f1[0];
					entities[1].sprite_f2 = (u8*) &G_shot2_f2[0];
					entities[0].attack--;
				}
				if (j == 2) { //HP max
					max_energy = 110;
					entities[0].energy = max_energy;
					//renderEnergy((u8*) 0x8000);
					renderEnergy((u8*) 0xC000);
				}
				if (j == 6) { //Ataque +1
					entities[0].attack++;
				}
				if (j == 10) { //Level +1
					levelUp();
				}
				break;
			}
		}
		if (!powerup) { //Si ya se cogieron todos los powerups, marcar todos como ocultos para que no se muestren más
			for (i=0;i<4;i++) {
				powerupsOnScreen[i] = 255;
			}
			renderPowerUp((u8*) 0x8000); //Actualizar pintado (el borrado realmente, hay que llamar en ambos buffers por si es el último power up en recoger, no se llamaría a este proc para el buffer actual)
			renderPowerUp((u8*) 0xC000); 
		}
		
	}
//cpct_setBorder(HW_BLACK);	
}

void extraLife(){
	u8 i;

	for (i=0;i<3;i++)
		pause();

	entities[0].energy = max_energy/2;
	entities[0].sprite_f1 = (u8*) &G_anima_down_f1[0];
	entities[0].sprite_f2 = (u8*) &G_anima_down_f2[0];
	//entities[0].x = 26;
	entities[0].immunity = RESET_ANIMA;
	powerups[3] = 3; //Marcar como gastado
	renderText((u8*) 0xC000,9,0);
	renderEnergy((u8*) 0xC000);
	end_screen = 0; //Continuar con la partida

	for (i=0;i<3;i++)
		pause();
}

void cementery() {
	u8 i;

	//
	for (i=4;i<48;i+=4) {
		cpct_drawSprite (&G_tile_10[0],  cpct_getScreenPtr (mem_start, i, 126), 4,16);
	}
	//estatua
	//cpct_drawSprite (&G_tile_12[0],  cpct_getScreenPtr (mem_start, 52, 110), 4,32);					
}

void ende() {
	u8 i;

	music_speed = 7;	 //La Música del menú va a velocidad 7
	cpct_akp_musicInit((u8*) m_menu);
	cpct_setVideoMemoryPage(mem_page);
	clearScreens();
	if (!color_changed) {
		*(u8*)&paletteM1[2] = HW_BRIGHT_GREEN; //Volver a dejarlo en verde
   		cpct_setPalette(paletteM1,4);
   	}

	renderScoreboard (mem_start);
	//Luna
	cpct_drawSprite (&G_tile_14,  cpct_getScreenPtr (mem_start, 44, 34), 4,16);
	if (powerups[11] == 0) { //Se cogió caramelo	
		cementery();	
		cpct_drawSprite (&G_final1[0],  cpct_getScreenPtr (mem_start, 24, 102), 5,40);
		mydrawStringM1(txtText_25, cpct_getScreenPtr(mem_start, 0, 170));
		mydrawStringM1(txtText_26, cpct_getScreenPtr(mem_start, 0, 180));
		entities[0].energy = 0; //para salir del loop principal al menú
	} else {
		cementery();
		cpct_drawSprite (&G_final2[0],  cpct_getScreenPtr (mem_start, 24, 108), 5, 28);
		cpct_drawSprite (G_power_up12,  cpct_getScreenPtr (mem_start, 40, 126), 4, 16);
		mydrawStringM1(txtText_27, cpct_getScreenPtr(mem_start, 0, 170));
		mydrawStringM1(txtText_28, cpct_getScreenPtr(mem_start, 0, 180));
		//Restaurar valores para la siguiente vuelta
		screen = 1;
		restart = 1;
		shuffleRooms();
	}
	

	for (i=0;i<10;i++)
		pause();
}


void exitScreen(){
	//intr:4, nota:E4 => (4*12)+5-1 = 52
	playFX (4, 52);
	
	entities[0].sprite_f1 = (u8*) &G_anima_up_f1[0];
	entities[0].sprite_f2 = (u8*) &G_anima_up_f2[0];
	
	while (entities[0].y) {
		waitBorder();
		changeVideoBuffer();
		entities[0].movV = -1;
		entities[0].movH = 0;
		movementsAllowed(); 
		waitBorder();
		renderDelete();  
	    renderSprites(); 
	}
	//OPT???entities[0].x_before_A = 0;
	//OPT???entities[0].x_before_B = 0;
	end_screen = 2;
	screen++;
	//OPT???enemies_ptr++;

	//Comprobar si hemos llegado al final del juego
	if (screen == /*2*/ LAST_SCREEN + 1)
		ende();	
}

void game() {

	screen = 1;
	/*screen = 2;
	rooms[screen] = 2;
	entities[0].attack = 4;*/

	while (entities[0].energy) { //Bucle de Partida
		//Preparar Fase
		initScreen();

		end_screen = 0;

		while (end_screen != 2) { //Bucle de Nivel
			new_score = 0;
			waitBorder();
			changeVideoBuffer();
			
			
//cpct_setBorder(HW_BLACK);
//******************** CICLO PROCESAMIENTO **************************
//cpct_setBorder(HW_YELLOW);
			keyboard(); //Movimiento
			//Disparo
			//Mientras recogemos powerups, no se muestra disparo
			if (powerup || end_screen) {
				entities[1].x = 0; 
			} else {
				if (!dual_stick)
					shoot();
				else
					shootDual();
			}
			

		    iA(); //IA Enemigos
		   	//cpct_setBorder(HW_YELLOW);
			movementsAllowed(); //Revisar movimientos y colisiones
			//cpct_setBorder(HW_BLACK);
			collisions();
			
			if (bonus > 1) {
				if (!end_screen && !powerup) {
					time--;	
				}

				if (!time) {
					bonus--;
					//renderText((u8*) 0x8000,12,0);
					renderText((u8*) 0xC000,12,0);
					renderBonus();
					time = RESET_TIME;
				}
			}			

			//Si nos queda poca energía, acelerar música
		    if (entities[0].energy < 30 && !music_changed){
		    	music_speed--;
		    	music_changed = 1;
		    }
		    //Si hemos subido de energía y se había acelerado, restaurar
		    if (entities[0].energy > 30 && music_changed){
		    	music_speed++;
		    	music_changed = 0;
		    }
			

//cpct_setBorder(HW_BLACK);			
			waitBorder();
//******************** CICLO BORRADO *********************************			
		    renderDelete(); 
		    //Borrar puertas
		    if (!powerup && !enemies_on_screen){
		    	end_screen = 1;
				if (entities[0].energy) {
					renderText(mem_start,3,0);
					//Borrar puertas 24+8, 4
					cpct_drawSolidBox (cpct_getScreenPtr (mem_start, 24, 4), 0x00,8, 16); 
				}
		    }
		    //Borrar texto cuando se termine el contador y restablecer la miniatura
		    if (!text_buffer){
		    	//renderText((u8*) 0x8000,0,0);
		    	renderText((u8*) 0xC000,0,0);
		    }
		    text_buffer--;

		    if (powerup) {
		    	renderPowerUp(mem_start);
		    }
//******************** CICLO PINTADO  *********************************
		    if (new_score) //Actualizar marcador de puntos sólo si hubo muerte de enemigo
				renderScore(score,90);

			if (score >= hiscore) {
    			hiscore = score;
    			// Si estamos continuamente superándolo (primera partida, añade mucha carga de CPU, se actualiza en pantalla sólo al pasar de fase)
    			//renderScore(hiscore,110);
    		}

		    renderSprites(); //Pintado-Pintar

		    swap_memvideo = ~swap_memvideo;
//****************** POWER-UPS *****************************************
		    //Vida extra
		    if (!powerups[3] && !entities[0].energy) {
	    		extraLife();
	    	}

	    	//Inmune aleatorio
		    if (!powerups[5] 
		    	&& (cpct_rand() == 0) 
		    	&& enemies_on_screen
		    	&& entities[0].immunity == 0) {
	    		entities[0].immunity = 80;
	    		//intr:7, nota:C3 => (3*12) + 1 -1 = 36
				playFX (7,36);
		    	renderText((u8*) 0xC000,10,0);
	    	}

	    	//salió por la puerta (Sólo puede llegar a esa coordenada y cuando fin_nivel > 0)
		    if (entities[0].y == 16) {
		    	//HP + 5, por no ser tocado
				if (!touched && entities[0].energy < max_energy) {
					entities[0].energy += 5;

					//intr:4, nota:E6 => (6*12)+5-1 = 76
					playFX (4, 76);
		    		renderText((u8*) 0xC000,13,0);
		    		pause();
				}

		    	//HP + 10, por powerup
				if (!powerups[7] && entities[0].energy < max_energy) {
					entities[0].energy += 10;

		    		renderText((u8*) 0xC000,11,0);
				}
				if (entities[0].energy > max_energy)
						entities[0].energy = max_energy;
					
				renderEnergy((u8*) 0xC000);
				exitScreen();
		    }

		/* *** */
		/*if (cpct_isKeyPressed(Key_N)) {
			entities[0].y = 0;
			exitScreen();
			}*/
		/* *** */
		}
		
	}
	cpct_setVideoMemoryPage(mem_page);
	pause();
	pauseKeyPressed();
}