#define SECOND 65535
#define MAX_ENTITIES 10
#define MAX_CELLS 128
#define MAX_CELLS_SCREEN 16 /***/ 
#define MAX_ENEMIES 257
#define PLAYAREA_SUP 20-1
#define PLAYAREA_INF 180+1
#define RESET_ANIMA 30 
#define RESET_ENEMY 20
#define RESET_TIME 0xFF
#define MAX_ENEMY_WIDTH 5
#define LAST_SCREEN 40
#define MAX_FLIPBUFFER 80
///////////////////////////////////////
#define ENERGY_ZOMBI 4
#define ENERGY_SCORPIO 2
#define ENERGY_BEE 1
#define ENERGY_DOG 6
#define ENERGY_SPIDER 4
#define ENERGY_BOSS1 20
#define ENERGY_SHARK 8
#define ENERGY_OCTOPUS 7
#define ENERGY_SNAKE 5
#define ENERGY_STARFISH 4
#define ENERGY_CROCODILE 6
#define ENERGY_BOSS2 45
#define ENERGY_SKULL 4
#define ENERGY_SKELETON 9
#define ENERGY_ARMOR 10
#define ENERGY_SLIME 8
#define ENERGY_DEMON 8
#define ENERGY_BOSS3 60
#define ENERGY_BAT 4
#define ENERGY_MUMMY 10
#define ENERGY_WITCH 8
#define ENERGY_FLAME 4
#define ENERGY_MONSTER 6
#define ENERGY_BOSS4 90

#define ATTACK_ZOMBI 5
#define ATTACK_SCORPIO 6
#define ATTACK_BEE 7
#define ATTACK_DOG 4
#define ATTACK_SPIDER 10
#define ATTACK_BOSS1 15
#define ATTACK_SHARK 6
#define ATTACK_OCTOPUS 14
#define ATTACK_SNAKE 5
#define ATTACK_STARFISH 10
#define ATTACK_CROCODILE 8
#define ATTACK_BOSS2 25
#define ATTACK_SKULL 7
#define ATTACK_SKELETON 10
#define ATTACK_ARMOR 10
#define ATTACK_SLIME 14
#define ATTACK_DEMON 20
#define ATTACK_BOSS3 20
#define ATTACK_BAT 10
#define ATTACK_MUMMY 12
#define ATTACK_WITCH 30
#define ATTACK_FLAME 8
#define ATTACK_MONSTER 6
#define ATTACK_BOSS4 20

#define CICLOS_DISPARO_PERSEGUIDOR 3  //Cada cuantos ciclos se mueve el disparo 'homing'


typedef struct {
   u8 id;
   u8 x;
   u8 y;
   i8 movV; //0=nada; -1=arriba;      1=abajo
   i8 movH; //0=nada; -1=izquierda;   1=derecha
   u8 x_before_A;
   u8 y_before_A;
   u8 x_before_B;
   u8 y_before_B;
   u8 height;
   u8 width;
   i8 data1;
   i8 data2;
   u8 energy;
   u8 attack;
//   u8 defensa;
   u8 immunity;
   u8 frozen;
   u8* sprite_f1; //sprite asociado frame 1
   u8* sprite_f2; //sprite asociado frame 2
   u8 flip;
} TEntity;

typedef struct {
   u8 room;
   u8 cell;
   u8 tile;
} TCell;

typedef struct {
   u8 x;
   u8 y;
   u8 cell;
} TCellBuffer;

typedef struct {
   u8 id;
   u8 x;
   u8 y;
} TEnemy;

extern const u8 paletteM1[4]; //Paleta de colores
extern const u8 titles[40][17]; //Títulos de cada pantalla
extern TEntity entities[MAX_ENTITIES]; //Array con las entidades activas
extern TCell cells[MAX_CELLS]; //Array con la info de las Celdas sólidas
extern TEnemy enemies[MAX_ENEMIES]; //Array con la info de los enemigos
extern TEnemy* enemies_ptr; //Puntero a enemigos de la fase actual
//extern u8 counter; //contador para saber cuando nos hemos salido del área de pintado
extern u8 music_counter; //contador para saber cuándo reproducir el siguiente trozo de música. Es diferente a contador para acelerar la música a nuestra voluntad
extern u8 time; //temporizador para bajar bonus si lleva tiempo sin derrotar enemigo
extern u8 music_speed;  //Velocidad de la música. 6 normal; menor valor, más rápida
//extern u8 color_black; //color negro para drawSolidBox (borrar)
extern u8* mem_start; //Dir Memoria del buffer de vídeo actual
extern u8 mem_page; //Página de vídeo actual
extern u8 swap_memvideo; //flag para saber cuando cambiar el buffer de vídeo
extern u8 max_energy; //Máxima energía posible para el jugador
extern u8 screen; //Pantalla por la que vamos (1-40)
extern u16 hiscore; //Máxima puntuación
extern u16 score; //Puntuación
extern u8 level; // level actual del jugador
extern u8 bonus; //multiplicador de puntos
extern u8 powerup; //Indicará si hay powerups pendientes de recoger al finalizar el nivel
extern u8 powerups[12]; //Los 12 powerups posibles 0:activo (en posesión); 1: posible recoger (los 4 que se muestran en pantalla); 2: oculto (no se posee); 3:gastado
extern u8 powerupsTaken[5]; // Los 5 posibles powerups que haya ido cogiendo el jugador
extern u8 ptr_powerupsTaken; //Puntero para anterior tabla
extern u8 target_level; //para llevar la cuenta de las subidas de nivel
extern u8 text_buffer; //El tiempo que estará el texto en pantalla
extern TCellBuffer cell_buffer[MAX_CELLS_SCREEN]; //Tener en un buffer sólo las celdas del nivel actual
extern u8 powerupsOnScreen[4]; //Guarda el índice [0..11] de los 4 power-ups mostrados en pantalla. Valor = 255 indica que se ha cogido
extern u8 frame; //contador de ciclos para saber cuándo cambiar la animación
extern u8 dual_stick; //Dos joysticks; mover y apuntar
extern u8 y_powerups; //Coordenada Y donde pintar los powerups (depende de dónde estaba el prota cuando limpió la pantalla)
extern u8 rooms[41]; //Tabla que contiene el orden de las pantallas (room); son 41 porque están numerados del 1 al 40, en vez del 0 al 39
extern u8 enemies_on_screen; //Enemigos que quedan en pantalla para pasar de nivel
extern u8 end_screen; //Se completó la pantalla
extern u8 afterIntro; //Flag que se activa tras la intro, para saber si se puede pintar en 0x8000
extern u8 language; //0=English; 1=Spanish
extern u8 flipbuffer[MAX_FLIPBUFFER]; //Bugger para el sprite girado
extern u8 touched; //Para saber si has recibido daño en una pantalla
extern u8 y1; //Para situar créditos de manera aleatoria
extern u8 y2;
extern u8 y3;
extern u8 restart; // Flag para ver si estamos en la segunda vuelta
extern u8 color_changed; //Marca para saber si se cambió la paleta estándar

extern u8 const txtText_1[8];
extern u8 const txtText_2[8];
//extern u8 const txtText_3[8];
extern u8 const txtText_4[10];
extern u8 const txtText_5[9];
extern u8 const txtText_6[9];
extern u8 const txtText_7[10];
extern u8 const txtText_8[9];
extern u8 const txtText_9[11];
extern u8 const txtText_10[8];
extern u8 const txtText_11[9];
extern u8 const txtText_12[9];
//extern u8 const txtText_13[10];
extern u8 const txtText_14[8];
extern u8 const txtText_15[9];
extern u8 const txtText_16[9];
extern u8 const txtText_17[10];
extern u8 const txtText_18[8];
//extern u8 const txtText_19[8];
extern u8 const txtText_20[9];
//extern u8 const txtText_21[10];
extern u8 const txtText_22[7];
extern u8 const txtText_23[7];
extern u8 const txtText_24[8];
extern u8 const txtText_25[24]; 
extern u8 const txtText_26[28];
extern u8 const txtText_27[28];
extern u8 const txtText_28[29];
extern u8 const txtText_29[22];
extern u8 const txtText_30[20];
extern u8 const txtText_31[23];
extern u8 const txtText_32[27];
extern u8 const txtText_33[10];


void waitBorder();
void playFX (u8 instrumento, u8 nota);
void mydrawStringM1 (void* string, void* video_memory) __z88dk_callee;